
#include <Keypad.h>
#include <LiquidCrystal_I2C.h>
#include "Talkie.h"
#include "Vocab_US_Large.h"
LiquidCrystal_I2C lcd(0x27,16,2);
Talkie voice;

int pushButton = 2;

float num1 = 0, num2 = 0;
float result = 0;
bool button = true;

char key;
const byte rows = 4;
const byte cols = 4;

char keys[rows][cols] = {
  {'1','2','3','+'},
  {'4','5','6','-'},
  {'7','8','9','*'},
  {'C','0','=','/'}
};
byte rowPins[rows] = {9, 8, 7, 6}; 
byte colPins[cols] = {5, 4, A1, A2}; 
Keypad keypad = Keypad(makeKeymap(keys), rowPins, colPins, rows, cols); 
int value, light; 

void setup(){
  Serial.begin(9600);
  lcd.init();
  lcd.backlight();
  pinMode(pushButton, INPUT_PULLUP);
}

void loop(){
  value = digitalRead(pushButton);
  if (value == 0) {
    button = !button;
    while (digitalRead(pushButton) == 0) {}
  }
  light = analogRead(A3);
  calculate();
}

void calculate() {
  //value = digitalRead(pushButton);
  key = keypad.getKey();
  //preia numarul de la keypad pana cand una dintre tastele de calcul este apasata
  if (key >= '0' && key <= '9') {
    num1 = num1 * 10 + (key - '0');
    lcd.setCursor(0,0);
    lcd.print(num1);
  }
  else if (key == '+') {
    if (num1 < 0) {
      if(button || light < 150) voice.say(sp3_MINUS);
      if(button || light < 150) say_number(num1 * (-1));
    } else if(button || light < 150) say_number(num1);
    if(button || light < 150) voice.say(sp3_PLUS);
    lcd.setCursor(15,0);
    lcd.print("+");
    num2 = getnum2(); 
    if(button || light < 150) say_number(num2);
    result = num1 + num2;
    showresult();
  }
  else if (key == '-') {
    if (num1 < 0) {
      if(button || light < 150) voice.say(sp3_MINUS);
      if(button || light < 150) say_number(num1 * (-1));
    } else if(button || light < 150) say_number(num1);
    if(button || light < 150) voice.say(sp3_MINUS);
    lcd.setCursor(15,0);
    lcd.print("-");
    num2 = getnum2();
    if(button || light < 150) say_number(num2);
    result = num1 - num2;
    showresult();
  }

  else if (key == '*') {
    if (num1 < 0) {
      if(button || light < 150) voice.say(sp3_MINUS);
      if(button || light < 150) say_number(num1 * (-1));
    } else if(button || light < 150) say_number(num1);
    if(button || light < 150) voice.say(sp3_TIMES);
    lcd.setCursor(15,0);
    lcd.print("*");
    num2 = getnum2();
    if(button || light < 150) say_number(num2);
    result = num1 * num2;
    showresult();
  }

  else if (key == '/') {
    if (num1 < 0) {
      if(button || light < 150) voice.say(sp3_MINUS);
      if(button || light < 150) say_number(num1 * (-1));
    } else if(button || light < 150) say_number(num1);
    if(button || light < 150) voice.say(sp3_DIVIDED);
    if(button || light < 150) voice.say(sp3_BY);
    lcd.setCursor(15,0);
    lcd.print("/");
    num2 = getnum2();
    if(button || light < 150) say_number(num2);
    result = (float)num1 / (float)num2;
    showresult();
  }

  else if (key == 'C') {
    if(button || light < 150) voice.say(sp3_CLEAR);
    result = 0;
    num1 = 0;
    num2 = 0;
    lcd.clear();
  }
}

//functie pentru a prelua al doilea numar
long getnum2() {
  while (1) {
    key = keypad.getKey();
    if (key >= '0' && key <= '9') {
      num2 = num2 * 10 + (key - '0');
      lcd.setCursor(0,1);
      lcd.print(num2);
    }
    if(key == '=') {
      break;
    }  
  }
  return num2; 
}

//functie pentru a afisa rezultatul si pentru a continua operatiile pornind de la acesta
void showresult() {
  lcd.setCursor(0,0);
  lcd.clear();
  lcd.print(result);
  if(button || light < 150) voice.say(sp3_EQUALS);
  if (result < 0) {
    if(button || light < 150) voice.say(sp3_MINUS);
    if(button || light < 150) say_number(result * (-1));
  } else if(button || light < 150) say_number(result);
  num1 = result;
  num2 = 0;
} 

String below_20[] = {"One", "Two", "Three", "Four","Five","Six","Seven","Eight","Nine","Ten", "Eleven","Twelve","Thirteen","Fourteen","Fifteen","Sixteen","Seventeen","Eighteen","Nineteen"};
String below_100[] = {"Twenty", "Thirty", "Fourty", "Fifty", "Sixty", "Seventy", "Eighty", "Ninety"};
String int_string(long n) {
  if (n >= 1000000000)   return int_string(n / 1000000000) + " Billion" + int_string(n - 1000000000 * (n / 1000000000));
  else if (n >= 1000000) return int_string(n / 1000000) + " Million" + int_string(n - 1000000 * (n / 1000000));
  else if (n >= 1000)    return int_string(n / 1000) + " Thousand" + int_string(n - 1000 * (n / 1000));
  else if (n >= 100)     return int_string(n / 100) + " Hundred" + int_string(n - 100 * (n / 100));
  else if (n >= 20)      return String(" ") + below_100[n / 10 - 2] + int_string(n - 10 * (n / 10));
  else if (n >= 1)       return String(" ") + below_20[n - 1];
  else return "";
}


void say_number(float number) {
  if (number == 0) {
    voice.say(sp3_ZERO);
  } else {
  String str = "";
  str.concat(number);
  String first_part = "";
  String second_part = "";
  int pos = str.length() - 1;
  for (int i = 0; i < str.length(); i++) {
    if (str[i] == '.') {
      pos = i;
      break;
    }
    first_part.concat(str[i]);
  }
  for (int i = pos + 1; i < str.length(); i++) {
    second_part.concat(str[i]);
  }
  long first = first_part.toInt();
  long second = second_part.toInt();
  String first_str = int_string(first);
  String second_str = int_string(second);
  String part = "";
  for (int i = 0; i < first_str.length(); i++) {
    if (first_str[i] != ' ') {
      part.concat(first_str[i]);
    } else {
      say_part(part);
      part = "";
    }
  }
  say_part(part);
  if (second_str.length() != 0 && second_str != "0") {
    voice.say(sp3_POINT);
    part = "";
    for (int i = 0; i < second_str.length(); i++) {
      if (second_str[i] != ' ') {
        part.concat(second_str[i]);
      } else {
        say_part(part);
        part = "";
      }
    }
    say_part(part);
  }
  }
}

void say_part(String s) {
  if (s == "One") voice.say(sp3_ONE);
  else if (s == "Two") voice.say(sp3_TWO);
  else if (s == "Three") voice.say(sp3_THREE);
  else if (s == "Four") voice.say(sp3_FOUR);
  else if (s == "Five") voice.say(sp3_FIVE);
  else if (s == "Six") voice.say(sp3_SIX);
  else if (s == "Seven") voice.say(sp3_SEVEN);
  else if (s == "Eight") voice.say(sp3_EIGHT);
  else if (s == "Nine") voice.say(sp3_NINE);
  else if (s == "Ten") voice.say(sp3_TEN);
  else if (s == "Eleven") voice.say(sp3_ELEVEN);
  else if (s == "Twelve") voice.say(sp3_TWELVE);
  else if (s == "Thirteen") voice.say(sp3_THIRTEEN);
  else if (s == "Fourteen") voice.say(sp3_FOURTEEN);
  else if (s == "Fifteen") voice.say(sp3_FIFTEEN);
  else if (s == "Sixteen") voice.say(sp3_SIXTEEN);
  else if (s == "Seventeen") voice.say(sp3_SEVENTEEN);
  else if (s == "Eighteen") voice.say(sp3_EIGHTEEN);
  else if (s == "Nineteen") voice.say(sp3_NINETEEN);
  else if (s == "Twenty") voice.say(sp3_TWENTY);
  else if (s == "Thirty") voice.say(sp3_THIRTY);
  else if (s == "Fourty") voice.say(sp3_FOURTY);
  else if (s == "Fifty") voice.say(sp3_FIFTY);
  else if (s == "Sixty") voice.say(sp3_SIXTY);
  else if (s == "Seventy") voice.say(sp3_SEVENTY);
  else if (s == "Eighty") voice.say(sp3_EIGHTY);
  else if (s == "Ninety") voice.say(sp3_NINETY);
  else if (s == "Hundred") voice.say(sp3_HUNDRED);
  else if (s == "Thousand") voice.say(sp3_THOUSAND);
  else if (s == "Million") voice.say(sp3_MILLION);   
}
